//+------------------------------------------------------------------+
//|                                            #_i_SpecktrAnalis.mq4 |
//|                                          Copyright  2006, klot. |
//|                                                     klot@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, klot."
#property link      "klot@mail.ru"



#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft);
#import

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_level1 0.0
//#property indicator_level1 0.0
//#property indicator_level1 0.0
//---- buffers
double Buffer1[];
double Buffer2[];
//---
/*
EURUSD D1
//1. frequency zone = 4 ( Fmin=3; Fmax=5)
//2. frequency zone = 7 (Fmin=6;Fmax=8)
//3. frequency zone = 9 (Fmin=8;Fmax=10)
//4. frequency zone = 14 (Fmin=13;Fmax=15)
//5. frequency zone = 18 (Fmin=17;Fmax=19)
//6. frequency zone = 21 (Fmin=20;Fmax=22)
//7. frequency zone = 24 (Fmin=23;Fmax=25)
//8. frequency zone = 27 (Fmin=26;Fmax=28)
//9. frequency zone = 34 (Fmin=33;Fmax=35)
//10. frequency zone = 63 (Fmin=61;Fmax=65)
//11. frequency zone = 90 (Fmin=88;Fmax=92)
*/
extern int n=7; //  

extern int Fmin0=2;
extern int Fmax0=128;
//1. frequency zone = 4 ( Fmin=3; Fmax=5)
extern int Fmin1=3;
extern int Fmax1=5;
//2. frequency zone = 7 (Fmin=6;Fmax=8)
extern int Fmin2=6;
extern int Fmax2=8;
//3. frequency zone = 9 (Fmin=8;Fmax=10)
extern int Fmin3=8;
extern int Fmax3=10;
//4. frequency zone = 14 (Fmin=13;Fmax=15)
extern int Fmin4=13;
extern int Fmax4=15;
//5. frequency zone = 18 (Fmin=17;Fmax=19)
extern int Fmin5=17;
extern int Fmax5=19;
//6. frequency zone = 21 (Fmin=20;Fmax=22)
extern int Fmin6=20;
extern int Fmax6=22;
//7. frequency zone = 24 (Fmin=23;Fmax=25)
extern int Fmin7=24;
extern int Fmax7=25;
//8. frequency zone = 27 (Fmin=26;Fmax=28)
extern int Fmin8=27;
extern int Fmax8=28;
//9. frequency zone = 34 (Fmin=33;Fmax=35)
extern int Fmin9=33;
extern int Fmax9=35;
//10. frequency zone = 63 (Fmin=61;Fmax=65)
extern int Fmin10=61;
extern int Fmax10=65;
//11. frequency zone = 90 (Fmin=88;Fmax=92)
extern int Fmin11=88;
extern int Fmax11=92;

//extern string sym="GBPUSD";
//extern string sym="EURUSD";

double aa[];
double bb[];
int N;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexStyle(0,DRAW_LINE,0,2);
SetIndexBuffer(0,Buffer1);
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,Buffer2);
//---
   N=MathPow(2,n);
   ArrayResize(aa,N);
   ArrayResize(bb,N);
/*
if( Fmax1>=N ) Fmax1=N;
if( Fmin1<=2 ) Fmin1=2;
if( Fmax2>=N ) Fmax2=N;
if( Fmin2<=2 ) Fmin2=2;
if( Fmax3>=N ) Fmax3=N;
if( Fmin3<=2 ) Fmin3=2;
if( Fmax4>=N ) Fmax4=N;
if( Fmin4<=2 ) Fmin4=2;
if( Fmax5>=N ) Fmax5=N;
if( Fmin5<=2 ) Fmin5=2;
if( Fmax6>=N ) Fmax6=N;
if( Fmin6<=2 ) Fmin6=2;
if( Fmax7>=N ) Fmax7=N;
if( Fmin7<=2 ) Fmin7=2;
if( Fmax8>=N ) Fmax8=N;
if( Fmin8<=2 ) Fmin8=2;
if( Fmax9>=N ) Fmax9=N;
if( Fmin9<=2 ) Fmin9=2;
*/
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   if( Bars<N) return(0);
   
   //---
   for(int i=N-1; i>=0; i--) 
   { 
     aa[i]=iClose(Symbol(),0,i); 
     bb[i]=iClose(Symbol(),0,i);
   }
   //---
   realfastfouriertransform(aa, N, false);
   realfastfouriertransform(bb, N, false);
   //---
   N=ArraySize(aa);
   //Comment("n= ",N);
   //---
   for( i=0; i<=N-1; i++) 
   { 
      if( 
          (i<Fmin1 || i>Fmax1) &&
          (i<Fmin2 || i>Fmax2) &&
          (i<Fmin3 || i>Fmax3) &&
          (i<Fmin4 || i>Fmax4) &&
          (i<Fmin5 || i>Fmax5) &&
          (i<Fmin6 || i>Fmax6) &&
          (i<Fmin7 || i>Fmax7) &&
          (i<Fmin8 || i>Fmax8) &&
          (i<Fmin9 || i>Fmax9) &&
          (i<Fmin10 || i>Fmax10) &&
          (i<Fmin11 || i>Fmax11)
      
        ) { aa[i]=0.0; }
      if( i<Fmin0 || i>Fmax0) { bb[i]=0.0; }  
   }
   //---
   realfastfouriertransform(aa, N, true);
   realfastfouriertransform(bb, N, true);
   //---
   SetIndexDrawBegin(0,Bars-N);
   SetIndexDrawBegin(1,Bars-N);
   //---
   for( i=0; i<=N-1; i++)
   {
      Buffer1[i]=aa[i];
      Buffer2[i]=bb[i];
   }
   //----
   return(0);
  }
//-------------------------------------------------------------------+